/* board-view.c generated by valac 0.56.18, the Vala compiler
 * generated from board-view.vala, do not modify */

/*
 * Copyright (C) 2018 Robert Roth
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <math.h>
#include <float.h>

#define BOARD_VIEW_size 5
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOARD_VIEW (board_view_get_type ())
#define BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD_VIEW, BoardView))
#define IS_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD_VIEW))
#define BOARD_VIEW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_BOARD_VIEW, BoardViewIface))

typedef struct _BoardView BoardView;
typedef struct _BoardViewIface BoardViewIface;

#define TYPE_PUZZLE_GENERATOR (puzzle_generator_get_type ())
#define PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGenerator))
#define PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))
#define IS_PUZZLE_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE_GENERATOR))
#define IS_PUZZLE_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE_GENERATOR))
#define PUZZLE_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE_GENERATOR, PuzzleGeneratorClass))

typedef struct _PuzzleGenerator PuzzleGenerator;
typedef struct _PuzzleGeneratorClass PuzzleGeneratorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BOARD_VIEW_COMPLETED_SIGNAL,
	BOARD_VIEW_GAME_WON_SIGNAL,
	BOARD_VIEW_LIGHT_TOGGLED_SIGNAL,
	BOARD_VIEW_NUM_SIGNALS
};
static guint board_view_signals[BOARD_VIEW_NUM_SIGNALS] = {0};

struct _BoardViewIface {
	GTypeInterface parent_iface;
	PuzzleGenerator* (*get_puzzle_generator) (BoardView* self);
	void (*clear_level) (BoardView* self);
	void (*toggle_light) (BoardView* self, gint x, gint y, gboolean user_initiated);
	gboolean (*is_light_active) (BoardView* self, gint x, gint y);
	GObject* (*get_light_at) (BoardView* self, gint x, gint y);
};

VALA_EXTERN GType puzzle_generator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PuzzleGenerator, g_object_unref)
VALA_EXTERN GType board_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoardView, g_object_unref)
VALA_EXTERN PuzzleGenerator* board_view_get_puzzle_generator (BoardView* self);
VALA_EXTERN void board_view_clear_level (BoardView* self);
VALA_EXTERN void board_view_toggle_light (BoardView* self,
                              gint x,
                              gint y,
                              gboolean user_initiated);
VALA_EXTERN gboolean board_view_is_light_active (BoardView* self,
                                     gint x,
                                     gint y);
VALA_EXTERN GObject* board_view_get_light_at (BoardView* self,
                                  gint x,
                                  gint y);
VALA_EXTERN void board_view_load_level (BoardView* self,
                            gint level);
VALA_EXTERN gboolean* puzzle_generator_minimal_solution (PuzzleGenerator* self,
                                             gint solution_length,
                                             gint* result_length1,
                                             gint* result_length2);
VALA_EXTERN void board_view_handle_toggle (BoardView* self,
                               GObject* light);
VALA_EXTERN void board_view_find_light (BoardView* self,
                            GObject* light,
                            gint* x,
                            gint* y);
VALA_EXTERN void board_view_move_to (BoardView* self,
                         gint x,
                         gint y);
VALA_EXTERN gboolean board_view_is_completed (BoardView* self);
static gboolean board_view_game_won_timeout (BoardView* self);
static gboolean _board_view_game_won_timeout_gsource_func (gpointer self);
static GType board_view_get_type_once (void);

PuzzleGenerator*
board_view_get_puzzle_generator (BoardView* self)
{
	BoardViewIface* _iface_;
#line 15 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 15 "../src/board-view.vala"
	_iface_ = BOARD_VIEW_GET_INTERFACE (self);
#line 15 "../src/board-view.vala"
	if (_iface_->get_puzzle_generator) {
#line 15 "../src/board-view.vala"
		return _iface_->get_puzzle_generator (self);
#line 122 "board-view.c"
	}
#line 15 "../src/board-view.vala"
	return NULL;
#line 126 "board-view.c"
}

void
board_view_clear_level (BoardView* self)
{
	BoardViewIface* _iface_;
#line 16 "../src/board-view.vala"
	g_return_if_fail (self != NULL);
#line 16 "../src/board-view.vala"
	_iface_ = BOARD_VIEW_GET_INTERFACE (self);
#line 16 "../src/board-view.vala"
	if (_iface_->clear_level) {
#line 16 "../src/board-view.vala"
		_iface_->clear_level (self);
#line 141 "board-view.c"
	}
}

void
board_view_toggle_light (BoardView* self,
                         gint x,
                         gint y,
                         gboolean user_initiated)
{
	BoardViewIface* _iface_;
#line 17 "../src/board-view.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/board-view.vala"
	_iface_ = BOARD_VIEW_GET_INTERFACE (self);
#line 17 "../src/board-view.vala"
	if (_iface_->toggle_light) {
#line 17 "../src/board-view.vala"
		_iface_->toggle_light (self, x, y, user_initiated);
#line 160 "board-view.c"
	}
}

gboolean
board_view_is_light_active (BoardView* self,
                            gint x,
                            gint y)
{
	BoardViewIface* _iface_;
#line 18 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 18 "../src/board-view.vala"
	_iface_ = BOARD_VIEW_GET_INTERFACE (self);
#line 18 "../src/board-view.vala"
	if (_iface_->is_light_active) {
#line 18 "../src/board-view.vala"
		return _iface_->is_light_active (self, x, y);
#line 178 "board-view.c"
	}
#line 18 "../src/board-view.vala"
	return FALSE;
#line 182 "board-view.c"
}

GObject*
board_view_get_light_at (BoardView* self,
                         gint x,
                         gint y)
{
	BoardViewIface* _iface_;
#line 20 "../src/board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/board-view.vala"
	_iface_ = BOARD_VIEW_GET_INTERFACE (self);
#line 20 "../src/board-view.vala"
	if (_iface_->get_light_at) {
#line 20 "../src/board-view.vala"
		return _iface_->get_light_at (self, x, y);
#line 199 "board-view.c"
	}
#line 20 "../src/board-view.vala"
	return NULL;
#line 203 "board-view.c"
}

void
board_view_load_level (BoardView* self,
                       gint level)
{
	gint solution_length = 0;
	gboolean* sol = NULL;
	PuzzleGenerator* _tmp0_;
	PuzzleGenerator* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gboolean* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint sol_length1;
	gint sol_length2;
#line 33 "../src/board-view.vala"
	if (level < 1) {
#line 34 "../src/board-view.vala"
		level = 1;
#line 226 "board-view.c"
	}
#line 36 "../src/board-view.vala"
	board_view_clear_level (self);
#line 38 "../src/board-view.vala"
	g_random_set_seed ((guint32) level);
#line 41 "../src/board-view.vala"
	solution_length = (gint) floor ((2 * log ((gdouble) level)) + 1);
#line 44 "../src/board-view.vala"
	_tmp0_ = board_view_get_puzzle_generator (self);
#line 44 "../src/board-view.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/board-view.vala"
	_tmp4_ = puzzle_generator_minimal_solution (_tmp1_, solution_length, &_tmp2_, &_tmp3_);
#line 44 "../src/board-view.vala"
	_tmp5_ = _tmp4_;
#line 44 "../src/board-view.vala"
	_tmp5__length1 = _tmp2_;
#line 44 "../src/board-view.vala"
	_tmp5__length2 = _tmp3_;
#line 44 "../src/board-view.vala"
	_g_object_unref0 (_tmp1_);
#line 44 "../src/board-view.vala"
	sol = _tmp5_;
#line 44 "../src/board-view.vala"
	sol_length1 = _tmp5__length1;
#line 44 "../src/board-view.vala"
	sol_length2 = _tmp5__length2;
#line 254 "board-view.c"
	{
		gint x = 0;
#line 45 "../src/board-view.vala"
		x = 0;
#line 259 "board-view.c"
		{
			gboolean _tmp6_ = FALSE;
#line 45 "../src/board-view.vala"
			_tmp6_ = TRUE;
#line 45 "../src/board-view.vala"
			while (TRUE) {
#line 45 "../src/board-view.vala"
				if (!_tmp6_) {
#line 268 "board-view.c"
					gint _tmp7_;
#line 45 "../src/board-view.vala"
					_tmp7_ = x;
#line 45 "../src/board-view.vala"
					x = _tmp7_ + 1;
#line 274 "board-view.c"
				}
#line 45 "../src/board-view.vala"
				_tmp6_ = FALSE;
#line 45 "../src/board-view.vala"
				if (!(x < BOARD_VIEW_size)) {
#line 45 "../src/board-view.vala"
					break;
#line 282 "board-view.c"
				}
				{
					gint y = 0;
#line 46 "../src/board-view.vala"
					y = 0;
#line 288 "board-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 46 "../src/board-view.vala"
						_tmp8_ = TRUE;
#line 46 "../src/board-view.vala"
						while (TRUE) {
#line 295 "board-view.c"
							gboolean* _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							gboolean _tmp11_;
#line 46 "../src/board-view.vala"
							if (!_tmp8_) {
#line 302 "board-view.c"
								gint _tmp9_;
#line 46 "../src/board-view.vala"
								_tmp9_ = y;
#line 46 "../src/board-view.vala"
								y = _tmp9_ + 1;
#line 308 "board-view.c"
							}
#line 46 "../src/board-view.vala"
							_tmp8_ = FALSE;
#line 46 "../src/board-view.vala"
							if (!(y < BOARD_VIEW_size)) {
#line 46 "../src/board-view.vala"
								break;
#line 316 "board-view.c"
							}
#line 47 "../src/board-view.vala"
							_tmp10_ = sol;
#line 47 "../src/board-view.vala"
							_tmp10__length1 = sol_length1;
#line 47 "../src/board-view.vala"
							_tmp10__length2 = sol_length2;
#line 47 "../src/board-view.vala"
							_tmp11_ = _tmp10_[(x * _tmp10__length2) + y];
#line 47 "../src/board-view.vala"
							if (_tmp11_) {
#line 48 "../src/board-view.vala"
								board_view_toggle_light (self, x, y, FALSE);
#line 330 "board-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 30 "../src/board-view.vala"
	sol = (g_free (sol), NULL);
#line 340 "board-view.c"
}

void
board_view_handle_toggle (BoardView* self,
                          GObject* light)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 51 "../src/board-view.vala"
	g_return_if_fail (light != NULL);
#line 54 "../src/board-view.vala"
	board_view_find_light (self, light, &_tmp0_, &_tmp1_);
#line 54 "../src/board-view.vala"
	x = _tmp0_;
#line 54 "../src/board-view.vala"
	y = _tmp1_;
#line 55 "../src/board-view.vala"
	board_view_move_to (self, x, y);
#line 361 "board-view.c"
}

void
board_view_find_light (BoardView* self,
                       GObject* light,
                       gint* x,
                       gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
#line 58 "../src/board-view.vala"
	g_return_if_fail (light != NULL);
#line 60 "../src/board-view.vala"
	_vala_y = 0;
#line 60 "../src/board-view.vala"
	_vala_x = _vala_y;
#line 378 "board-view.c"
	{
		gboolean _tmp0_ = FALSE;
#line 61 "../src/board-view.vala"
		_vala_x = 0;
#line 61 "../src/board-view.vala"
		_tmp0_ = TRUE;
#line 61 "../src/board-view.vala"
		while (TRUE) {
#line 61 "../src/board-view.vala"
			if (!_tmp0_) {
#line 389 "board-view.c"
				gint _tmp1_;
#line 61 "../src/board-view.vala"
				_tmp1_ = _vala_x;
#line 61 "../src/board-view.vala"
				_vala_x = _tmp1_ + 1;
#line 395 "board-view.c"
			}
#line 61 "../src/board-view.vala"
			_tmp0_ = FALSE;
#line 61 "../src/board-view.vala"
			if (!(_vala_x < BOARD_VIEW_size)) {
#line 61 "../src/board-view.vala"
				break;
#line 403 "board-view.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 62 "../src/board-view.vala"
				_vala_y = 0;
#line 62 "../src/board-view.vala"
				_tmp2_ = TRUE;
#line 62 "../src/board-view.vala"
				while (TRUE) {
#line 413 "board-view.c"
					GObject* _tmp4_;
					GObject* _tmp5_;
					gboolean _tmp6_;
#line 62 "../src/board-view.vala"
					if (!_tmp2_) {
#line 419 "board-view.c"
						gint _tmp3_;
#line 62 "../src/board-view.vala"
						_tmp3_ = _vala_y;
#line 62 "../src/board-view.vala"
						_vala_y = _tmp3_ + 1;
#line 425 "board-view.c"
					}
#line 62 "../src/board-view.vala"
					_tmp2_ = FALSE;
#line 62 "../src/board-view.vala"
					if (!(_vala_y < BOARD_VIEW_size)) {
#line 62 "../src/board-view.vala"
						break;
#line 433 "board-view.c"
					}
#line 63 "../src/board-view.vala"
					_tmp4_ = board_view_get_light_at (self, _vala_x, _vala_y);
#line 63 "../src/board-view.vala"
					_tmp5_ = _tmp4_;
#line 63 "../src/board-view.vala"
					_tmp6_ = _tmp5_ == light;
#line 63 "../src/board-view.vala"
					_g_object_unref0 (_tmp5_);
#line 63 "../src/board-view.vala"
					if (_tmp6_) {
#line 64 "../src/board-view.vala"
						if (x) {
#line 64 "../src/board-view.vala"
							*x = _vala_x;
#line 449 "board-view.c"
						}
#line 64 "../src/board-view.vala"
						if (y) {
#line 64 "../src/board-view.vala"
							*y = _vala_y;
#line 455 "board-view.c"
						}
#line 64 "../src/board-view.vala"
						return;
#line 459 "board-view.c"
					}
				}
			}
		}
	}
#line 58 "../src/board-view.vala"
	if (x) {
#line 58 "../src/board-view.vala"
		*x = _vala_x;
#line 469 "board-view.c"
	}
#line 58 "../src/board-view.vala"
	if (y) {
#line 58 "../src/board-view.vala"
		*y = _vala_y;
#line 475 "board-view.c"
	}
}

static gboolean
_board_view_game_won_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = board_view_game_won_timeout ((BoardView*) self);
#line 74 "../src/board-view.vala"
	return result;
#line 486 "board-view.c"
}

void
board_view_move_to (BoardView* self,
                    gint x,
                    gint y)
{
#line 69 "../src/board-view.vala"
	board_view_toggle_light (self, x, y, TRUE);
#line 70 "../src/board-view.vala"
	g_signal_emit (self, board_view_signals[BOARD_VIEW_LIGHT_TOGGLED_SIGNAL], 0);
#line 71 "../src/board-view.vala"
	if (board_view_is_completed (self)) {
#line 73 "../src/board-view.vala"
		g_signal_emit (self, board_view_signals[BOARD_VIEW_COMPLETED_SIGNAL], 0);
#line 74 "../src/board-view.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _board_view_game_won_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 504 "board-view.c"
	}
}

static gboolean
board_view_game_won_timeout (BoardView* self)
{
	gboolean result;
#line 80 "../src/board-view.vala"
	g_signal_emit (self, board_view_signals[BOARD_VIEW_GAME_WON_SIGNAL], 0);
#line 81 "../src/board-view.vala"
	result = G_SOURCE_REMOVE;
#line 81 "../src/board-view.vala"
	return result;
#line 518 "board-view.c"
}

gboolean
board_view_is_completed (BoardView* self)
{
	gboolean result;
	{
		gint x = 0;
#line 86 "../src/board-view.vala"
		x = 0;
#line 529 "board-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 86 "../src/board-view.vala"
			_tmp0_ = TRUE;
#line 86 "../src/board-view.vala"
			while (TRUE) {
#line 86 "../src/board-view.vala"
				if (!_tmp0_) {
#line 538 "board-view.c"
					gint _tmp1_;
#line 86 "../src/board-view.vala"
					_tmp1_ = x;
#line 86 "../src/board-view.vala"
					x = _tmp1_ + 1;
#line 544 "board-view.c"
				}
#line 86 "../src/board-view.vala"
				_tmp0_ = FALSE;
#line 86 "../src/board-view.vala"
				if (!(x < BOARD_VIEW_size)) {
#line 86 "../src/board-view.vala"
					break;
#line 552 "board-view.c"
				}
				{
					gint y = 0;
#line 87 "../src/board-view.vala"
					y = 0;
#line 558 "board-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 87 "../src/board-view.vala"
						_tmp2_ = TRUE;
#line 87 "../src/board-view.vala"
						while (TRUE) {
#line 87 "../src/board-view.vala"
							if (!_tmp2_) {
#line 567 "board-view.c"
								gint _tmp3_;
#line 87 "../src/board-view.vala"
								_tmp3_ = y;
#line 87 "../src/board-view.vala"
								y = _tmp3_ + 1;
#line 573 "board-view.c"
							}
#line 87 "../src/board-view.vala"
							_tmp2_ = FALSE;
#line 87 "../src/board-view.vala"
							if (!(y < BOARD_VIEW_size)) {
#line 87 "../src/board-view.vala"
								break;
#line 581 "board-view.c"
							}
#line 88 "../src/board-view.vala"
							if (board_view_is_light_active (self, x, y)) {
#line 89 "../src/board-view.vala"
								result = FALSE;
#line 89 "../src/board-view.vala"
								return result;
#line 589 "board-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 91 "../src/board-view.vala"
	result = TRUE;
#line 91 "../src/board-view.vala"
	return result;
#line 601 "board-view.c"
}

static void
board_view_default_init (BoardViewIface * iface,
                         gpointer iface_data)
{
#line 11 "../src/board-view.vala"
	board_view_signals[BOARD_VIEW_COMPLETED_SIGNAL] = g_signal_new ("completed", TYPE_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11 "../src/board-view.vala"
	board_view_signals[BOARD_VIEW_GAME_WON_SIGNAL] = g_signal_new ("game-won", TYPE_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11 "../src/board-view.vala"
	board_view_signals[BOARD_VIEW_LIGHT_TOGGLED_SIGNAL] = g_signal_new ("light-toggled", TYPE_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 614 "board-view.c"
}

static GType
board_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoardViewIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_view_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType board_view_type_id;
	board_view_type_id = g_type_register_static (G_TYPE_INTERFACE, "BoardView", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (board_view_type_id, G_TYPE_OBJECT);
	return board_view_type_id;
}

GType
board_view_get_type (void)
{
	static volatile gsize board_view_type_id__once = 0;
	if (g_once_init_enter (&board_view_type_id__once)) {
		GType board_view_type_id;
		board_view_type_id = board_view_get_type_once ();
		g_once_init_leave (&board_view_type_id__once, board_view_type_id);
	}
	return board_view_type_id__once;
}

